Index: frontends/php/include/services.inc.php
===================================================================
--- frontends/php/include/services.inc.php	(revision 38884)
+++ frontends/php/include/services.inc.php	(working copy)
@@ -27,10 +27,6 @@
 			}
 		}
 
-		if (is_null($triggerid) || $triggerid == 0) {
-			$triggerid = 'NULL';
-		}
-
 		$serviceid = get_dbid('services', 'serviceid');
 
 		// removes all links with current serviceid
@@ -51,9 +47,16 @@
 			return false;
 		}
 
+		if (is_null($triggerid) || $triggerid == 0) {
+			$triggerid = 'NULL';
+		}
+		else {
+			$triggerid = zbx_dbstr($triggerid);
+		}
+
 		$result = DBexecute('INSERT INTO services (serviceid,name,status,triggerid,algorithm,showsla,goodsla,sortorder)'.
 							' VALUES ('.$serviceid.','.zbx_dbstr($name).',0,'.$triggerid.','.zbx_dbstr($algorithm).
-								','.$showsla.','.zbx_dbstr($goodsla).','.$sortorder.')');
+								','.zbx_dbstr($showsla).','.zbx_dbstr($goodsla).','.zbx_dbstr($sortorder).')');
 		if (!$result) {
 			return false;
 		}
@@ -61,12 +64,12 @@
 		// updating status to all services by the dependency
 		update_services_status_all();
 
-		DBExecute('DELETE FROM services_times WHERE serviceid='.$serviceid);
+		DBExecute('DELETE FROM services_times WHERE serviceid='.zbx_dbstr($serviceid));
 
 		foreach ($service_times as $val) {
 			$timeid = get_dbid('services_times', 'timeid');
 			$result = DBexecute('INSERT INTO services_times (timeid,serviceid,type,ts_from,ts_to,note)'.
-				' values ('.$timeid.','.$serviceid.','.$val['type'].','.$val['from'].','.$val['to'].','.zbx_dbstr($val['note']).')');
+				' values ('.$timeid.','.zbx_dbstr($serviceid).','.zbx_dbstr($val['type']).','.zbx_dbstr($val['from']).','.zbx_dbstr($val['to']).','.zbx_dbstr($val['note']).')');
 			if (!$result) {
 				delete_service($serviceid);
 				return false;
@@ -104,12 +107,15 @@
 		if (is_null($triggerid) || $triggerid == 0) {
 			$triggerid = 'NULL';
 		}
+		else {
+			$triggerid = zbx_dbstr($triggerid);
+		}
 
 		$result = DBexecute('UPDATE services'.
 							' SET name='.zbx_dbstr($name).
-								',triggerid='.$triggerid.',status=0,algorithm='.$algorithm.
-								',showsla='.$showsla.',goodsla='.$goodsla.',sortorder='.$sortorder.
-							' WHERE serviceid='.$serviceid);
+								',triggerid='.$triggerid.',status=0,algorithm='.zbx_dbstr($algorithm).
+								',showsla='.zbx_dbstr($showsla).',goodsla='.zbx_dbstr($goodsla).',sortorder='.zbx_dbstr($sortorder).
+							' WHERE serviceid='.zbx_dbstr($serviceid));
 
 		// updating status to all services by the dependency
 		update_services_status_all();
@@ -119,7 +125,7 @@
 		foreach ($service_times as $val) {
 			$timeid = get_dbid('services_times', 'timeid');
 			DBexecute('INSERT INTO services_times (timeid,serviceid,type,ts_from,ts_to,note)'.
-				' VALUES ('.$timeid.','.$serviceid.','.$val['type'].','.$val['from'].','.$val['to'].','.zbx_dbstr($val['note']).')');
+				' VALUES ('.$timeid.','.zbx_dbstr($serviceid).','.zbx_dbstr($val['type']).','.zbx_dbstr($val['from']).','.zbx_dbstr($val['to']).','.zbx_dbstr($val['note']).')');
 		}
 
 		return $result;
@@ -131,7 +137,7 @@
 							' WHERE h.hostid=i.hostid'.
 								' AND i.itemid=f.itemid'.
 								' AND f.triggerid=t.triggerid'.
-								' AND h.hostid='.$hostid.
+								' AND h.hostid='.zbx_dbstr($hostid).
 								' AND '.DBin_node('t.triggerid', false)
 							);
 		while ($row = DBfetch($result)) {
@@ -142,7 +148,7 @@
 	}
 
 	function is_service_hardlinked($serviceid) {
-		$row = DBfetch(DBselect('SELECT COUNT(*) as cnt FROM services_links sl WHERE sl.servicedownid='.$serviceid.' and sl.soft=0'));
+		$row = DBfetch(DBselect('SELECT COUNT(*) as cnt FROM services_links sl WHERE sl.servicedownid='.zbx_dbstr($serviceid).' and sl.soft=0'));
 		if ($row && $row['cnt'] > 0) {
 			return true;
 		}
@@ -171,7 +177,7 @@
 
 			$result = DBselect('SELECT s.status'.
 					' FROM services s,services_links l'.
-					' WHERE l.serviceupid='.$serviceid.
+					' WHERE l.serviceupid='.zbx_dbstr($serviceid).
 						' AND s.serviceid=l.servicedownid'.
 					' ORDER BY s.status '.$sort_order);
 			if ($row = DBfetch($result)) {
@@ -187,22 +193,22 @@
 	 *                                                                            *
 	 ******************************************************************************/
 	function delete_service($serviceid) {
-		$sql = 'DELETE FROM services_links WHERE servicedownid='.$serviceid.' OR serviceupid='.$serviceid;
+		$sql = 'DELETE FROM services_links WHERE servicedownid='.zbx_dbstr($serviceid).' OR serviceupid='.zbx_dbstr($serviceid);
 		if (!$result = DBexecute($sql)) {
 			return $result;
 		}
 
-		$sql = 'DELETE FROM services WHERE serviceid='.$serviceid;
+		$sql = 'DELETE FROM services WHERE serviceid='.zbx_dbstr($serviceid);
 		if (!$result = DBexecute($sql)) {
 			return $result;
 		}
 
-		$sql = 'DELETE FROM service_alarms WHERE serviceid='.$serviceid;
+		$sql = 'DELETE FROM service_alarms WHERE serviceid='.zbx_dbstr($serviceid);
 		if (!$result = DBexecute($sql)) {
 			return $result;
 		}
 
-		$sql = 'DELETE FROM services_times WHERE serviceid='.$serviceid;
+		$sql = 'DELETE FROM services_times WHERE serviceid='.zbx_dbstr($serviceid);
 		if (!$result = DBexecute($sql)) {
 			return $result;
 		}
@@ -225,7 +231,7 @@
 	 */
 	function clear_parents_from_trigger($serviceid = 0) {
 		if ($serviceid != 0) {
-			DBexecute('UPDATE services SET triggerid=NULL WHERE serviceid='.$serviceid);
+			DBexecute('UPDATE services SET triggerid=NULL WHERE serviceid='.zbx_dbstr($serviceid));
 			return null;
 		}
 
@@ -235,7 +241,7 @@
 								' AND NOT s.triggerid IS NULL'.
 							' GROUP BY s.serviceid');
 		while ($row = DBfetch($result)) {
-			DBexecute('UPDATE services SET triggerid=NULL WHERE serviceid='.$row['serviceid']);
+			DBexecute('UPDATE services SET triggerid=NULL WHERE serviceid='.zbx_dbstr($row['serviceid']));
 		}
 	}
 
@@ -252,7 +258,7 @@
 			}
 		}
 
-		$result = DBselect('SELECT sl.serviceupid FROM services_links sl WHERE sl.servicedownid='.$serviceid2.' and sl.soft=0');
+		$result = DBselect('SELECT sl.serviceupid FROM services_links sl WHERE sl.servicedownid='.zbx_dbstr($serviceid2).' and sl.soft=0');
 		while ($row = DBfetch($result)) {
 			if (does_service_depend_on_the_service($serviceid, $row['serviceupid']) == true) {
 				return true;
@@ -274,7 +280,7 @@
 
 		$linkid = get_dbid('services_links', 'linkid');
 
-		$result = DBexecute('INSERT INTO services_links (linkid,servicedownid,serviceupid,soft) values ('.$linkid.','.$servicedownid.','.$serviceupid.','.$softlink.')');
+		$result = DBexecute('INSERT INTO services_links (linkid,servicedownid,serviceupid,soft) values ('.$linkid.','.zbx_dbstr($servicedownid).','.zbx_dbstr($serviceupid).','.zbx_dbstr($softlink).')');
 
 		if (!$result) {
 			return $result;
@@ -284,7 +290,7 @@
 	}
 
 	function remove_service_links($serviceid) {
-		DBExecute('DELETE FROM services_links WHERE serviceupid='.$serviceid.' OR (servicedownid='.$serviceid.' AND soft<>1)');
+		DBExecute('DELETE FROM services_links WHERE serviceupid='.zbx_dbstr($serviceid).' OR (servicedownid='.zbx_dbstr($serviceid).' AND soft<>1)');
 	}
 
 	function get_last_service_value($serviceid, $clock) {
@@ -293,8 +299,8 @@
 		$result = DBselect(
 			'SELECT MAX(sa.clock) AS clock'.
 			' FROM service_alarms sa'.
-			' WHERE sa.serviceid='.$serviceid.
-				' AND sa.clock<'.$clock
+			' WHERE sa.serviceid='.zbx_dbstr($serviceid).
+				' AND sa.clock<'.zbx_dbstr($clock)
 		);
 		$row = DBfetch($result);
 		if ($row && !is_null($row['clock'])) {
@@ -302,8 +308,8 @@
 			$result2 = DBselect(
 				'SELECT sa.value'.
 				' FROM service_alarms sa'.
-				' WHERE sa.serviceid='.$serviceid.
-					' AND sa.clock='.$row['clock'].
+				' WHERE sa.serviceid='.zbx_dbstr($serviceid).
+					' AND sa.clock='.zbx_dbstr($row['clock']).
 				' ORDER BY sa.servicealarmid DESC', 1
 			);
 			if ($row2 = DBfetch($result2)) {
@@ -370,7 +376,7 @@
 		$result = DBselect(
 			'SELECT sa.servicealarmid,sa.clock,sa.value'.
 			' FROM service_alarms sa'.
-			' WHERE sa.serviceid='.$serviceid.
+			' WHERE sa.serviceid='.zbx_dbstr($serviceid).
 				' AND sa.clock BETWEEN '.$period_start.' AND '.$period_end.
 			' ORDER BY sa.clock,sa.servicealarmid'
 		);
@@ -385,7 +391,7 @@
 			'SELECT st.ts_from,st.ts_to'.
 			' FROM services_times st'.
 			' WHERE st.type='.SERVICE_TIME_TYPE_UPTIME.
-				' AND st.serviceid='.$serviceid
+				' AND st.serviceid='.zbx_dbstr($serviceid)
 		);
 		while ($row = DBfetch($result)) {
 			expandPeriodicalServiceTimes($data, $period_start, $period_end, $row['ts_from'], $row['ts_to'], 'ut');
@@ -399,7 +405,7 @@
 			'SELECT st.ts_from,st.ts_to'.
 			' FROM services_times st'.
 			' WHERE st.type='.SERVICE_TIME_TYPE_DOWNTIME.
-				' AND st.serviceid='.$serviceid
+				' AND st.serviceid='.zbx_dbstr($serviceid)
 		);
 		while ($row = DBfetch($result)) {
 			expandPeriodicalServiceTimes($data, $period_start, $period_end, $row['ts_from'], $row['ts_to'], 'dt');
@@ -410,9 +416,9 @@
 			'SELECT st.ts_from,st.ts_to'.
 			' FROM services_times st'.
 			' WHERE st.type='.SERVICE_TIME_TYPE_ONETIME_DOWNTIME.
-				' AND st.ts_to>='.$period_start.
-				' AND st.ts_from<='.$period_end.
-				' AND st.serviceid='.$serviceid
+				' AND st.ts_to>='.zbx_dbstr($period_start).
+				' AND st.ts_from<='.zbx_dbstr($period_end).
+				' AND st.serviceid='.zbx_dbstr($serviceid)
 		);
 		while ($row = DBfetch($result)) {
 			if ($row['ts_from'] < $period_start) {
@@ -553,7 +559,7 @@
 
 		$query = 'SELECT sl.servicedownid'.
 				' FROM services_links sl'.
-				' WHERE sl.serviceupid='.$serviceid.($soft ? '' : ' AND sl.soft<>1');
+				' WHERE sl.serviceupid='.zbx_dbstr($serviceid).($soft ? '' : ' AND sl.soft<>1');
 
 		$result = DBselect($query);
 		while ($row = DBfetch($result)) {
@@ -653,7 +659,7 @@
 		$result = DBselect('SELECT l.serviceupid,s.algorithm'.
 							' FROM services_links l,services s'.
 							' WHERE s.serviceid=l.serviceupid'.
-								' AND l.servicedownid='.$serviceid
+								' AND l.servicedownid='.zbx_dbstr($serviceid)
 							);
 		while ($row = DBfetch($result)) {
 			$serviceupid = $row['serviceupid'];
@@ -662,7 +668,7 @@
 			if ($algorithm == SERVICE_ALGORITHM_MAX || $algorithm == SERVICE_ALGORITHM_MIN) {
 				$status = get_service_status($serviceupid, $algorithm);
 				add_service_alarm($serviceupid, $status, time());
-				DBexecute('UPDATE services SET status='.$status.' WHERE serviceid='.$serviceupid);
+				DBexecute('UPDATE services SET status='.zbx_dbstr($status).' WHERE serviceid='.zbx_dbstr($serviceupid));
 			}
 			elseif ($algorithm != SERVICE_ALGORITHM_NONE) {
 				error(S_UNKNOWN_CALC_ALGORITHM_OF_SERVICE_STATUS.SPACE.'['.$algorithm.']');
@@ -670,7 +676,7 @@
 			}
 		}
 
-		$result = DBselect('SELECT sl.serviceupid FROM services_links sl WHERE sl.servicedownid='.$serviceid);
+		$result = DBselect('SELECT sl.serviceupid FROM services_links sl WHERE sl.servicedownid='.zbx_dbstr($serviceid));
 		while ($row = DBfetch($result)) {
 			$serviceupid = $row['serviceupid'];
 			update_services_rec($serviceupid);	// ATTENTION: recursion!!!
@@ -695,9 +701,9 @@
 	 *                                                                            *
 	 ******************************************************************************/
 	function update_services($triggerid, $status) {
-		DBexecute('UPDATE services SET status='.$status.' WHERE triggerid='.$triggerid);
+		DBexecute('UPDATE services SET status='.zbx_dbstr($status).' WHERE triggerid='.zbx_dbstr($triggerid));
 
-		$result = DBselect('SELECT s.serviceid FROM services s WHERE s.triggerid='.$triggerid);
+		$result = DBselect('SELECT s.serviceid FROM services s WHERE s.triggerid='.zbx_dbstr($triggerid));
 		while ($row = DBfetch($result)) {
 			add_service_alarm($row['serviceid'], $status, time());
 			update_services_rec($row['serviceid']);
@@ -721,7 +727,7 @@
 							' WHERE s.serviceid NOT IN (select distinct sl.serviceupid from services_links sl)');
 		while ($row = DBfetch($result)) {
 			$status = get_service_status($row['serviceid'], $row['algorithm'], $row['triggerid']);
-			DBexecute('UPDATE services SET status='.$status.' WHERE serviceid='.$row['serviceid']);
+			DBexecute('UPDATE services SET status='.zbx_dbstr($status).' WHERE serviceid='.zbx_dbstr($row['serviceid']));
 			add_service_alarm($row['serviceid'], $status, time());
 		}
 
@@ -742,7 +748,7 @@
 	function latest_service_alarm($serviceid, $status) {
 		$result = DBselect('SELECT sa.servicealarmid,sa.value'.
 							' FROM service_alarms sa'.
-							' WHERE sa.serviceid='.$serviceid.
+							' WHERE sa.serviceid='.zbx_dbstr($serviceid).
 							' ORDER BY sa.servicealarmid DESC', 1);
 		$row = DBfetch($result);
 		if ($row && $row['value'] == $status) {
@@ -760,6 +766,6 @@
 		if (latest_service_alarm($serviceid, $status)) {
 			return true;
 		}
-		return DBexecute('INSERT INTO service_alarms (servicealarmid,serviceid,clock,value) VALUES ('.get_dbid('service_alarms', 'servicealarmid').','.$serviceid.','.$clock.','.$status.')');
+		return DBexecute('INSERT INTO service_alarms (servicealarmid,serviceid,clock,value) VALUES ('.get_dbid('service_alarms', 'servicealarmid').','.zbx_dbstr($serviceid).','.zbx_dbstr($clock).','.zbx_dbstr($status).')');
 	}
 ?>
Index: frontends/php/include/profiles.inc.php
===================================================================
--- frontends/php/include/profiles.inc.php	(revision 38884)
+++ frontends/php/include/profiles.inc.php	(working copy)
@@ -134,8 +134,8 @@
 			'userid' => $USER_DETAILS['userid'],
 			'idx' => zbx_dbstr($idx),
 			$value_type => ($value_type == 'value_str') ? zbx_dbstr($value) : $value,
-			'type' => $type,
-			'idx2' => $idx2
+			'type' => zbx_dbstr($type),
+			'idx2' => zbx_dbstr($idx2)
 		);
 
 		$sql = 'INSERT INTO profiles ('.implode(', ', array_keys($values)).') VALUES ('.implode(', ', $values).')';
@@ -156,8 +156,8 @@
 		$value = ($value_type == 'value_str') ? zbx_dbstr($value) : $value;
 
 		$sql = 'UPDATE profiles SET '.
-					$value_type.'='.$value.','.
-					' type='.$type.
+					$value_type.'='.zbx_dbstr($value).','.
+					' type='.zbx_dbstr($type).
 				' WHERE userid='.$USER_DETAILS['userid'].
 					' AND idx='.zbx_dbstr($idx).
 					$sql_cond;
@@ -382,7 +382,7 @@
 		'profileid' => get_dbid('profiles', 'profileid'),
 		'userid' => $USER_DETAILS['userid'],
 		'idx' => zbx_dbstr($favobj),
-		'value_id' =>  $favid,
+		'value_id' => zbx_dbstr($favid),
 		'type' => PROFILE_TYPE_ID
 	);
 	if(!is_null($source)) $values['source'] = zbx_dbstr($source);
@@ -402,7 +402,7 @@
 	$sql = 'DELETE FROM profiles '.
 		' WHERE userid='.$USER_DETAILS['userid'].
 			' AND idx='.zbx_dbstr($favobj).
-			(($favid > 0) ? ' AND value_id='.$favid : '').
+			(($favid > 0) ? ' AND value_id='.zbx_dbstr($favid) : '').
 			(is_null($source) ? '' : ' AND source='.zbx_dbstr($source));
 
 	return DBexecute($sql);
Index: frontends/php/include/graphs.inc.php
===================================================================
--- frontends/php/include/graphs.inc.php	(revision 38884)
+++ frontends/php/include/graphs.inc.php	(working copy)
@@ -138,7 +138,7 @@
 
 		$sql = 'SELECT MAX(g.graphtype) as graphtype, MIN(gi.yaxisside) as yaxissidel, MAX(gi.yaxisside) as yaxissider, MAX(g.height) as height'.
 				' FROM graphs g, graphs_items gi '.
-				' WHERE g.graphid='.$graphid.
+				' WHERE g.graphid='.zbx_dbstr($graphid).
 					' AND gi.graphid=g.graphid ';
 		$res = DBselect($sql);
 		if($graph=DBfetch($res)){
@@ -172,7 +172,7 @@
 				' FROM graphs g, graphs_items gi, items i '.
 				' WHERE g.graphid=gi.graphid '.
 					' AND gi.itemid=i.itemid '.
-					' AND i.hostid='.$hostid;
+					' AND i.hostid='.zbx_dbstr($hostid);
 	return DBselect($sql);
 	}
 
@@ -189,13 +189,13 @@
 							' FROM graphs_items gi, items i, hosts h'.
 							' WHERE h.hostid=i.hostid '.
 								' AND gi.itemid=i.itemid '.
-								' AND gi.graphid='.$graphid);
+								' AND gi.graphid='.zbx_dbstr($graphid));
 	}
 
 	function get_graphitems_by_graphid($graphid){
 		return DBselect('SELECT * '.
 					' FROM graphs_items '.
-					' WHERE graphid='.$graphid.
+					' WHERE graphid='.zbx_dbstr($graphid).
 					' ORDER BY itemid,drawtype,sortorder,color,yaxisside');
 	}
 
@@ -216,7 +216,7 @@
 		$itemids = array();
 		$sql = 'SELECT DISTINCT gi.itemid '.
 				' FROM graphs_items gi '.
-				' WHERE gi.graphid='.$graphid;
+				' WHERE gi.graphid='.zbx_dbstr($graphid);
 		$res = DBselect($sql);
 		while($item = DBfetch($res)){
 			$itemids[$item['itemid']] = $item['itemid'];
@@ -310,7 +310,7 @@
 
 	function get_graph_by_graphid($graphid){
 
-		$result=DBselect("SELECT * FROM graphs WHERE graphid=$graphid");
+		$result=DBselect('SELECT * FROM graphs WHERE graphid='.zbx_dbstr($graphid));
 		$row=DBfetch($result);
 		if($row){
 			return	$row;
@@ -343,9 +343,9 @@
 		foreach($gitems as $gitem){
 			$sql = 'SELECT src.itemid, dest.key_ '.
 					' FROM items src, items dest '.
-					' WHERE dest.itemid='.$gitem['itemid'].
+					' WHERE dest.itemid='.zbx_dbstr($gitem['itemid']).
 						' AND src.key_=dest.key_ '.
-						' AND src.hostid='.$dest_hostid;
+						' AND src.hostid='.zbx_dbstr($dest_hostid);
 			$db_item = DBfetch(DBselect($sql));
 			if (!$db_item && $error){
 				$item = get_item_by_itemid($gitem['itemid']);
@@ -386,8 +386,11 @@
 
 		$result=DBexecute('INSERT INTO graphs '.
 			' (graphid,name,width,height,ymin_type,ymax_type,yaxismin,yaxismax,ymin_itemid,ymax_itemid,templateid,show_work_period,show_triggers,graphtype,show_legend,show_3d,percent_left,percent_right) '.
-			" VALUES ($graphid,".zbx_dbstr($name).",$width,$height,$ymin_type,$ymax_type,$yaxismin,$yaxismax,$ymin_itemid,$ymax_itemid,".
-			" $templateid,$showworkperiod,$showtriggers,$graphtype,$legend,$graph3d,$percent_left,$percent_right)");
+			' VALUES ('.$graphid.','.zbx_dbstr($name).','.zbx_dbstr($width).','.zbx_dbstr($height).','.
+				zbx_dbstr($ymin_type).','.zbx_dbstr($ymax_type).','.zbx_dbstr($yaxismin).','.zbx_dbstr($yaxismax).','.
+				zbx_dbstr($ymin_itemid).','.zbx_dbstr($ymax_itemid).','.zbx_dbstr($templateid).','.
+				zbx_dbstr($showworkperiod).','.zbx_dbstr($showtriggers).','.zbx_dbstr($graphtype).','.zbx_dbstr($legend).','.
+				zbx_dbstr($graph3d).','.zbx_dbstr($percent_left).','.zbx_dbstr($percent_right));
 
 		return ( $result ? $graphid : $result);
 	}
@@ -507,28 +510,28 @@
 
 		$sql = 'UPDATE graphs SET '.
 				'name='.zbx_dbstr($name).','.
-				'width='.$width.','.
-				'height='.$height.','.
-				'ymin_type='.$ymin_type.','.
-				'ymax_type='.$ymax_type.','.
-				'yaxismin='.$yaxismin.','.
-				'yaxismax='.$yaxismax.','.
-				'ymin_itemid='.$ymin_itemid.','.
-				'ymax_itemid='.$ymax_itemid.','.
-				'templateid='.$templateid.','.
-				'show_work_period='.$showworkperiod.','.
-				'show_triggers='.$showtriggers.','.
-				'graphtype='.$graphtype.','.
-				'show_legend='.$legend.','.
-				'show_3d='.$graph3d.','.
-				'percent_left='.$percent_left.','.
-				'percent_right='.$percent_right.
-			' WHERE graphid='.$graphid;
+				'width='.zbx_dbstr($width).','.
+				'height='.zbx_dbstr($height).','.
+				'ymin_type='.zbx_dbstr($ymin_type).','.
+				'ymax_type='.zbx_dbstr($ymax_type).','.
+				'yaxismin='.zbx_dbstr($yaxismin).','.
+				'yaxismax='.zbx_dbstr($yaxismax).','.
+				'ymin_itemid='.zbx_dbstr($ymin_itemid).','.
+				'ymax_itemid='.zbx_dbstr($ymax_itemid).','.
+				'templateid='.zbx_dbstr($templateid).','.
+				'show_work_period='.zbx_dbstr($showworkperiod).','.
+				'show_triggers='.zbx_dbstr($showtriggers).','.
+				'graphtype='.zbx_dbstr($graphtype).','.
+				'show_legend='.zbx_dbstr($legend).','.
+				'show_3d='.zbx_dbstr($graph3d).','.
+				'percent_left='.zbx_dbstr($percent_left).','.
+				'percent_right='.zbx_dbstr($percent_right).
+			' WHERE graphid='.zbx_dbstr($graphid);
 
 		if($result = DBexecute($sql)){
 			if($g_graph['graphtype'] != $graphtype && $graphtype == GRAPH_TYPE_STACKED){
 				$result = DBexecute('UPDATE graphs_items SET calc_fnc='.CALC_FNC_AVG.',drawtype=1,type='.GRAPH_ITEM_SIMPLE.
-					' WHERE graphid='.$graphid);
+					' WHERE graphid='.zbx_dbstr($graphid));
 			}
 		}
 		return $result;
@@ -600,7 +603,7 @@
 			}
 		}
 
-		DBexecute('DELETE FROM graphs_items WHERE graphid='.$graphid);
+		DBexecute('DELETE FROM graphs_items WHERE graphid='.zbx_dbstr($graphid));
 
 		foreach($gitems as $gitem){
 			if (!$result = add_item_to_graph(
@@ -740,8 +743,8 @@
 
 		$result = DBexecute('insert into graphs_items'.
 			' (gitemid,graphid,itemid,color,drawtype,sortorder,yaxisside,calc_fnc,type,periods_cnt)'.
-			' values ('.$gitemid.','.$graphid.','.$itemid.','.zbx_dbstr($color).','.$drawtype.','.
-			$sortorder.','.$yaxisside.','.$calc_fnc.','.$type.','.$periods_cnt.')');
+			' values ('.$gitemid.','.zbx_dbstr($graphid).','.zbx_dbstr($itemid).','.zbx_dbstr($color).','.zbx_dbstr($drawtype).','.
+			zbx_dbstr($sortorder).','.zbx_dbstr($yaxisside).','.zbx_dbstr($calc_fnc).','.zbx_dbstr($type).','.zbx_dbstr($periods_cnt).')');
 
 		return ( $result ? $gitemid : $result );
 	}
@@ -780,7 +783,7 @@
 			}
 
 			if ($unlink_mode) {
-				if (DBexecute('UPDATE graphs SET templateid=0 WHERE graphid='.$db_graph['graphid'])) {
+				if (DBexecute('UPDATE graphs SET templateid=0 WHERE graphid='.zbx_dbstr($db_graph['graphid']))) {
 					info(S_GRAPH.SPACE.'"'.$host['host'].':'.$db_graph['name'].'"'.SPACE.S_UNLINKED_SMALL);
 				}
 			}
Index: frontends/php/include/db.inc.php
===================================================================
--- frontends/php/include/db.inc.php	(revision 38884)
+++ frontends/php/include/db.inc.php	(working copy)
@@ -129,7 +129,7 @@
 						);
 						db2_set_option($DB['DB'], $options, 1);
 						if(isset($DB['SCHEMA']) && ($DB['SCHEMA'] != '')){
-							DBexecute("SET CURRENT SCHEMA='".$DB['SCHEMA']."'");
+							DBexecute('SET CURRENT SCHEMA='.zbx_dbstr($DB['SCHEMA']));
 						}
 					}
 
Index: frontends/php/include/scripts.inc.php
===================================================================
--- frontends/php/include/scripts.inc.php	(revision 38884)
+++ frontends/php/include/scripts.inc.php	(working copy)
@@ -1,7 +1,7 @@
 <?php
 
 function get_script_by_scriptid($scriptid){
-	$sql = 'SELECT * FROM scripts WHERE scriptid='.$scriptid;
+	$sql = 'SELECT * FROM scripts WHERE scriptid='.zbx_dbstr($scriptid);
 
 	$rows = false;
 	if($res = DBSelect($sql)){
@@ -13,7 +13,7 @@
 function add_script($name,$command,$usrgrpid,$groupid,$access){
 	$scriptid = get_dbid('scripts','scriptid');
 	$sql = 'INSERT INTO scripts (scriptid,name,command,usrgrpid,groupid,host_access) '.
-				" VALUES ($scriptid,".zbx_dbstr($name).','.zbx_dbstr($command).",$usrgrpid,$groupid,$access)";
+				' VALUES ('.$scriptid.','.zbx_dbstr($name).','.zbx_dbstr($command).','.zbx_dbstr($usrgrpid).','.zbx_dbstr($groupid).','.zbx_dbstr($access).')';
 	$result = DBexecute($sql);
 	if($result){
 		$result = $scriptid;
@@ -35,18 +35,18 @@
 	$sql = 'UPDATE scripts SET '.
 				' name='.zbx_dbstr($name).
 				' ,command='.zbx_dbstr($command).
-				' ,usrgrpid='.$usrgrpid.
-				' ,groupid='.$groupid.
-				' ,host_access='.$access.
-			' WHERE scriptid='.$scriptid;
+				' ,usrgrpid='.zbx_dbstr($usrgrpid).
+				' ,groupid='.zbx_dbstr($groupid).
+				' ,host_access='.zbx_dbstr($access).
+			' WHERE scriptid='.zbx_dbstr($scriptid);
 
 	$result = DBexecute($sql);
 return $result;
 }
 
 function script_make_command($scriptid,$hostid){
-	$host_db = DBfetch(DBselect('SELECT dns,useip,ip FROM hosts WHERE hostid='.$hostid));
-	$script_db = DBfetch(DBselect('SELECT command FROM scripts WHERE scriptid='.$scriptid));
+	$host_db = DBfetch(DBselect('SELECT dns,useip,ip FROM hosts WHERE hostid='.zbx_dbstr($hostid)));
+	$script_db = DBfetch(DBselect('SELECT command FROM scripts WHERE scriptid='.zbx_dbstr($scriptid)));
 
 	if($host_db && $script_db){
 		$command = $script_db['command'];
Index: frontends/php/include/reports.inc.php
===================================================================
--- frontends/php/include/reports.inc.php	(revision 38884)
+++ frontends/php/include/reports.inc.php	(working copy)
@@ -58,10 +58,10 @@
 		$cmbHGrps->addItem(0,S_ALL_SMALL);
 
 		$sql_cond = ' AND h.hostid=ht.hostid ';
-		if($_REQUEST['hostid'] > 0)	$sql_cond.=' AND ht.templateid='.$_REQUEST['hostid'];
+		if($_REQUEST['hostid'] > 0)	$sql_cond.=' AND ht.templateid='.zbx_dbstr($_REQUEST['hostid']);
 
 		if(isset($_REQUEST['tpl_triggerid']) && ($_REQUEST['tpl_triggerid'] > 0))
-			$sql_cond.= ' AND t.templateid='.$_REQUEST['tpl_triggerid'];
+			$sql_cond.= ' AND t.templateid='.zbx_dbstr($_REQUEST['tpl_triggerid']);
 
 		$result = DBselect('SELECT DISTINCT g.groupid,g.name '.
 			' FROM triggers t,hosts h,items i,functions f, hosts_templates ht, groups g, hosts_groups hg '.
@@ -85,7 +85,7 @@
 				);
 		}
 
-		$sql_cond=($_REQUEST['hostid'] > 0)?' AND h.hostid='.$_REQUEST['hostid']:' AND '.DBcondition('h.hostid',$available_hosts);
+		$sql_cond=($_REQUEST['hostid'] > 0)?' AND h.hostid='.zbx_dbstr($_REQUEST['hostid']):' AND '.DBcondition('h.hostid',$available_hosts);
 		$sql = 'SELECT DISTINCT t.triggerid,t.description '.
 			' FROM triggers t,hosts h,items i,functions f '.
 			' WHERE f.itemid=i.itemid '.
Index: frontends/php/include/classes/class.cchart.php
===================================================================
--- frontends/php/include/classes/class.cchart.php	(revision 38884)
+++ frontends/php/include/classes/class.cchart.php	(working copy)
@@ -250,9 +250,9 @@
 						' count(*) as count,avg(value) as avg,min(value) as min,'.
 						' max(value) as max,max(clock) as clock'.
 					' FROM history '.
-					' WHERE itemid='.$this->items[$i]['itemid'].
-						' AND clock>='.$from_time.
-						' AND clock<='.$to_time.
+					' WHERE itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND clock>='.zbx_dbstr($from_time).
+						' AND clock<='.zbx_dbstr($to_time).
 					' GROUP BY itemid,'.$calc_field
 					,
 
@@ -260,9 +260,9 @@
 						' count(*) as count,avg(value) as avg,min(value) as min,'.
 						' max(value) as max,max(clock) as clock'.
 					' FROM history_uint '.
-					' WHERE itemid='.$this->items[$i]['itemid'].
-						' AND clock>='.$from_time.
-						' AND clock<='.$to_time.
+					' WHERE itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND clock>='.zbx_dbstr($from_time).
+						' AND clock<='.zbx_dbstr($to_time).
 					' GROUP BY itemid,'.$calc_field
 					);
 			}
@@ -273,9 +273,9 @@
 						' sum(num) as count,avg(value_avg) as avg,min(value_min) as min,'.
 						' max(value_max) as max,max(clock) as clock'.
 					' FROM trends '.
-					' WHERE itemid='.$this->items[$i]['itemid'].
-						' AND clock>='.$from_time.
-						' AND clock<='.$to_time.
+					' WHERE itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND clock>='.zbx_dbstr($from_time).
+						' AND clock<='.zbx_dbstr($to_time).
 					' GROUP BY itemid,'.$calc_field
 					,
 
@@ -283,9 +283,9 @@
 						' sum(num) as count,avg(value_avg) as avg,min(value_min) as min,'.
 						' max(value_max) as max,max(clock) as clock'.
 					' FROM trends_uint '.
-					' WHERE itemid='.$this->items[$i]['itemid'].
-						' AND clock>='.$from_time.
-						' AND clock<='.$to_time.
+					' WHERE itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND clock>='.zbx_dbstr($from_time).
+						' AND clock<='.zbx_dbstr($to_time).
 					' GROUP BY itemid,'.$calc_field
 					);
 
@@ -451,7 +451,7 @@
 						' AND tr.status='.TRIGGER_STATUS_ENABLED.
 						' AND i.itemid=f.itemid '.
 						' AND h.hostid=i.hostid '.
-						' AND f.itemid='.$item['itemid'].
+						' AND f.itemid='.zbx_dbstr($item['itemid']).
 					' ORDER BY tr.priority';
 			$db_triggers = DBselect($sql);
 			while(($trigger = DBfetch($db_triggers)) && ($cnt < $max)){
Index: frontends/php/include/classes/class.cpie.php
===================================================================
--- frontends/php/include/classes/class.cpie.php	(revision 38884)
+++ frontends/php/include/classes/class.cpie.php	(working copy)
@@ -179,9 +179,9 @@
 						' max(h.value) AS max,max(h.clock) AS clock, max(i.lastvalue) as lst '.
 					' FROM history h '.
 						' LEFT JOIN items i ON h.itemid = i.itemid'.
-					' WHERE h.itemid='.$this->items[$i]['itemid'].
-						' AND h.clock>='.$from_time.
-						' AND h.clock<='.$to_time.
+					' WHERE h.itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND h.clock>='.zbx_dbstr($from_time).
+						' AND h.clock<='.zbx_dbstr($to_time).
 					' GROUP BY h.itemid'
 					,
 
@@ -190,9 +190,9 @@
 						' max(hu.value) AS max,max(hu.clock) AS clock, max(i.lastvalue) as lst'.
 					' FROM history_uint hu '.
 						' LEFT JOIN items i ON hu.itemid = i.itemid'.
-					' WHERE hu.itemid='.$this->items[$i]['itemid'].
-						' AND hu.clock>='.$from_time.
-						' AND hu.clock<='.$to_time.
+					' WHERE hu.itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND hu.clock>='.zbx_dbstr($from_time).
+						' AND hu.clock<='.zbx_dbstr($to_time).
 					' GROUP BY hu.itemid'
 					);
 			}
@@ -204,9 +204,9 @@
 						' max(t.value_max) AS max,max(t.clock) AS clock, max(i.lastvalue) as lst'.
 					' FROM trends t '.
 						' LEFT JOIN items i ON t.itemid = i.itemid'.
-					' WHERE t.itemid='.$this->items[$i]['itemid'].
-						' AND t.clock>='.$from_time.
-						' AND t.clock<='.$to_time.
+					' WHERE t.itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND t.clock>='.zbx_dbstr($from_time).
+						' AND t.clock<='.zbx_dbstr($to_time).
 					' GROUP BY t.itemid'
 					,
 
@@ -215,9 +215,9 @@
 						' max(t.value_max) AS max,max(t.clock) AS clock, max(i.lastvalue) as lst'.
 					' FROM trends_uint t '.
 						' LEFT JOIN items i ON t.itemid = i.itemid'.
-					' WHERE t.itemid='.$this->items[$i]['itemid'].
-						' AND t.clock>='.$from_time.
-						' AND t.clock<='.$to_time.
+					' WHERE t.itemid='.zbx_dbstr($this->items[$i]['itemid']).
+						' AND t.clock>='.zbx_dbstr($from_time).
+						' AND t.clock<='.zbx_dbstr($to_time).
 					' GROUP BY t.itemid'
 					);
 			}
